<?
/****************************************************************************
COMMON_FUNCTION
 + ist eine Funktionssammlung um fr "vermisste" IPS-Funktionalitten einen
	Workaround zu haben

	... PARESY nicht bse sein :-) --> kannst die Funktionen gerne optimiert
	    in den Kernel mitaufnehmen

	... http://www.ip-symcon.de/forum/f53/ip-symcon-variablenzugriffe-ueber-namen-7231/

Release: 0.8.2 BETA
ReleaseDate: 11.01.2012

ReleaseNote:
02.04.2009 - R0.1 - Gusenbauer
 + erste Funktionen angelegt und getestet

01.05.2009 - R0.2 - Gusenbauer
 + der IPS-Gemeinde zur Verfgung gestellt

01.05.2009 - R0.3 - Gusenbauer
 + Allen Funktionen um die Mglichkeit gegeben mit relativen Pfad umzugehen zu koennen
   ... ein relativer Pfad beginnt mit "./"
 + neue Funktion GetValueByName

04.05.2009 - R0.3.1 - Gusenbauer
 + Alle IPS - Funktionen mit @Funktionsnamen aufgerufen,
   dass deren Debugmeldungen nicht mehr durchkommen
 + CheckCreateVariable gendert
 + Fuer SetValue*ByName eine globale interne Funktion _SetValueByName eingefuehrt

05.05.2009 - R0.3.2 - Gusenbauer
 + neue Funktionen (*CC = Check and Create)
		  - SetValueBooleanByNameCC
		  - SetValueIntegerByNameCC
		  - SetValueFloatByNameCC
		  - SetValueStringByNameCC
 + Funktion _SetValueByName erweitert um fehlende Hierachieebenen
   mit Kategorieelementen zu fllen und automatischer Variablenerstellung
	wenn CheckCreate = 1

15.05.2009 - R0.4 - Gusenbauer
 + Relativer Pfad erweitert um folgende Funktionalitaeten
	 - /   ==> Ebene unterhalb des Scriptes
	 - ./  ==> Ebene wie Script
	 - ../ ==> Ebene oberhalb des Scriptes
 + neue Funktion GetVariableByName
 + Bereitstellung der IPS-Communitiy als R0.4

13.07.2009 - R0.5 - Gusenbauer
 + BUGFIX --> _SetValueByName --> bei relativen Pfad Variable "$PathString"
   initialisieren, hat zu "Warnings" in IPS2.1 Beta gefuehrt
	==> wegen error_reporting=E_ALL
 + Bereitstellung der IPS-Communitiy als R0.5

31.07.2009 - R0.6 - Gusenbauer
 + BUGFIX in CheckCreateVariable ==> Warning in IPS2.1 Beta
 + Bereitstellung der IPS-Community als R0.6

09.09.2009 - R0.7 - Gusenbauer
 + GetValueFormattedByName ==> neue Funktion eingefhrt
 + CheckScriptExistsByName ==> neue Funktion eingefhrt
 + SetValue*ByNameCC um Parameter "VariablenProfil", "VariablenProfilActionScript" und "VariablenInfoText"
                     erweitert beim anlegen der Variable
							(ein nachtrgliches ndern einer existierenden Variable ist nicht mglich)
 + CheckCreateVariable ==> Erweitert wie SetValue*CC
 + Bereitstellung der IPS-Community als R0.7

07.11.2009 - R0.8b - Gusenbauer
 + Neue Functionen UUID / GUID (Globaly Unique IDentiffier)

21.04.2010 - R0.8.1b - Gusenbauer
 + IPS_SELF mit global uebergeben

11.01.2012 - R0.8.2b - Gusenbauer
 + global IPS_SELF jetzt auf $_IPS geaendert und eben mit $IPS['SELF'] abgefragt
   (soll ja zur IPS3.0 dann Standard werden und die Emulation wegfallen)

*****************************************************************************/


function CreateScriptByName($ScriptNAME, $ParentID, $ScriptTEXT)
{
    global $_IPS;
    $ScriptID = @IPS_GetScriptIDByName($ScriptNAME, $ParentID);
    if ($ScriptID == 0){

       $ScriptID = IPS_CreateScript(0);
       IPS_SetName($ScriptID, $ScriptNAME);
       IPS_SetParent($ScriptID, $ParentID);
       IPS_SetInfo($ScriptID, "This script was created by: #". $_IPS['SELF'] ."#");
        $fh = fopen(IPS_GetKernelDir()."scripts\\".$ScriptID.".ips.php", 'w') or die("can't open file");
        fwrite($fh, $ScriptTEXT);
        fclose($fh);
        $ScriptPath = $ScriptID.".ips.php";     //Skriptdatei
        IPS_SetScriptFile($ScriptID, $ScriptPath);
        IPS_SetHidden($ScriptID, true);
       // echo "Die Skript-ID lautet: ". $ScriptID;
    }
}


/****************************************************************************
GetValueByName,
  liest die Variable des Variableenstring aus

  + Als Trennstrich wird ein Schrgstrich verwendet "/"
		sollte jedoch der Aufruf mit Backslash "\" passieren
		wird dieser automatisch konveriert

Example:  $Wert = GetValueByName("AAA/BBB/CCC/DDD/TESTVAR1");

ReleaseNotes:
01.05.2009 Gusenbauer
 + Function erstellt und geprft
15.05.2009 Gusenbauer
 + Relativer Pfad erweitert um
	 - /   ==> Ebene unterhalb des Scriptes
	 - ./  ==> Ebene wie Script
	 - ../ ==> Ebene oberhalb des Scriptes
*****************************************************************************/

function GetValueByName($Name)
{
  $NewID = 0; //RootID
  $Name = str_replace(chr(92),"/",$Name);
  $msgtxt ="";

  if (substr($Name,0,1) == "/")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene unterhalb einordnen (Ebene unterhalb des Scriptes)
      global $_IPS;
 		$NewID = $_IPS['SELF'];
		$Name = substr($Name,1);
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - /";
	  }

  if (substr($Name,0,2) == "./")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie wie Script (Scriptebene)
      global $_IPS;
		$ObjectInfo = IPS_GetObject($_IPS['SELF']);
		$NewID = $ObjectInfo['ParentID'];
		$Name = substr($Name,2);
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ./";
	  }

  if (substr($Name,0,3) == "../")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene hher einordnen (Ebene ber Script)
      global $_IPS;
		$ObjectInfo = IPS_GetObject($_IPS['SELF']);
		$ObjectInfo = IPS_GetObject($ObjectInfo['ParentID']);
		$NewID = $ObjectInfo['ParentID'];
		$Name = substr($Name,3);
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ../";
	  }

  foreach (explode("/", $Name) as $NameTag)
   {
	 $PrevID = $NewID;
	 $NewID = @IPS_GetObjectIDByName($NameTag,$PrevID);
	  if (@IPS_GetName($NewID) != $NameTag)
		  {
		   echo "FEHLER: Pfad / Variable '" . $NameTag ."' existiert nicht !!(" . $msgtxt . $Name . ")\r\n";
			return false;
			break;
		  }
	}

  if ($NameTag != "")
	  {
	   if (@IPS_GetVariableIDByName($NameTag,$PrevID) >= 1)
		   {
			 //Wert von der Variable lesen und zureuckgeben
			 return GetValue($NewID);
		   }
		else
			{
          echo "FEHLER: Variable '" . $NameTag . "' existiert nicht !!! (" . $msgtxt . $Name . ")\r\n";
          return false;
			}
	  }
	else
	  {
      echo "FEHLER: als VARIABLENNAME konnte nur ein Leerstring ermittel werden !!! (" . $msgtxt . $Name . ")\r\n";
      return false;
	  }
 }


/****************************************************************************
GetVariableByName,
  liest die Variable des Variableenstring aus und gibt ein INFO-Array zurck

  + Als Trennstrich wird ein Schrgstrich verwendet "/"
		sollte jedoch der Aufruf mit Backslash "\" passieren
		wird dieser automatisch konveriert

Example:  $VarInfoArray = GetVariableByName("AAA/BBB/CCC/DDD/TESTVAR_ABSOLUT_PFAD");

          echo $VarInfoArray['ID'] . "\r\n";
          echo $VarInfoArray['NAME'] . "\r\n";
          echo $VarInfoArray['VALUE'] . "\r\n";
          echo $VarInfoArray['TS_UPDATE'] . "\r\n";
          echo $VarInfoArray['TS_CHANGE'] . "\r\n";
          echo $VarInfoArray['TS_UPDATE_UNIX'] . "\r\n";
          echo $VarInfoArray['TS_CHANGE_UNIX'] . "\r\n";

          erzeugt folgende Ausgabe
			 45226
          TESTVAR_ABSOLUT_PFAD
          1
          15.05.2009 23:34:43
          15.05.2009 21:42:56
          1242423283.093
          1242416576.109

ReleaseNotes:
15.05.2009 Gusenbauer
 + Funktion erstellt
*****************************************************************************/

function GetVariableByName($VaribalenPathName)
  {
    $VaribalenID = @CheckObjektHierachie($VaribalenPathName);
    $VARINFO_ARRAY = array();

    if($VaribalenID >= 1)
      {
       $VariablenID_INFO = @IPS_GetObject($VaribalenID);
       if ($VariablenID_INFO['ObjectType'] == 2) //Check ob Objekt eine Variable ist
          {
           $VarInfo = @IPS_GetVariable($VaribalenID);

           $VARINFO_ARRAY['ID']              = $VariablenID_INFO['ObjectID'];
           $VARINFO_ARRAY['NAME']            = $VariablenID_INFO['ObjectName'];
           $VARINFO_ARRAY['VALUE']           = GetValue($VaribalenID);
           $VARINFO_ARRAY['TS_UPDATE']       = date("d.m.Y H:i:s", $VarInfo['VariableUpdated']);
           $VARINFO_ARRAY['TS_CHANGE']       = date("d.m.Y H:i:s", $VarInfo['VariableChanged']);
           $VARINFO_ARRAY['TS_UPDATE_UNIX']  = $VarInfo['VariableUpdated'];
           $VARINFO_ARRAY['TS_CHANGE_UNIX']  = $VarInfo['VariableChanged'];
          }
      }
    else
      {
        exit("FEHLER: Variable : '" . $VaribalenPathName ."' ist nicht in IPS vorhanden !!\r\n");
      }

   return $VARINFO_ARRAY;
  }


/****************************************************************************
GetValueFormattedByName,
  liest die Variable des Variableenstring aus und gibt den formatierten Wert
  zurck, ist kein Varibalenprofil aktiv wird der unformtierte Wert zurckgegeben
  (dieser unformatierte wert wird als String konvertiert)
   ==> "" wird als "0" zurckgegeben !!!

  + Als Trennstrich wird ein Schrgstrich verwendet "/"
		sollte jedoch der Aufruf mit Backslash "\" passieren
		wird dieser automatisch konveriert

Example:  $Wert = GetValueFormattedByName("AAA/BBB/CCC/DDD/TESTVAR1");

ReleaseNotes:
01.09.2009 Gusenbauer
 + Function erstellt und geprft
*****************************************************************************/

function GetValueFormattedByName($Name)
{
  $NewID = 0; //RootID
  $Name = str_replace(chr(92),"/",$Name);
  $msgtxt ="";

  if (substr($Name,0,1) == "/")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene unterhalb einordnen (Ebene unterhalb des Scriptes)
      global $_IPS;
 		$NewID = $_IPS['SELF'];
		$Name = substr($Name,1);
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - /";
	  }

  if (substr($Name,0,2) == "./")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie wie Script (Scriptebene)
      global $_IPS;
		$ObjectInfo = IPS_GetObject($_IPS['SELF']);
		$NewID = $ObjectInfo['ParentID'];
		$Name = substr($Name,2);
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ./";
	  }

  if (substr($Name,0,3) == "../")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene hher einordnen (Ebene ber Script)
      global $_IPS;
		$ObjectInfo = IPS_GetObject($_IPS['SELF']);
		$ObjectInfo = IPS_GetObject($ObjectInfo['ParentID']);
		$NewID = $ObjectInfo['ParentID'];
		$Name = substr($Name,3);
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ../";
	  }

  foreach (explode("/", $Name) as $NameTag)
   {
	 $PrevID = $NewID;
	 $NewID = @IPS_GetObjectIDByName($NameTag,$PrevID);
	  if (@IPS_GetName($NewID) != $NameTag)
		  {
		   echo "FEHLER: Pfad / Variable '" . $NameTag ."' existiert nicht !!(" . $msgtxt . $Name . ")\r\n";
			return false;
			break;
		  }
	}

  if ($NameTag != "")
	  {
	   if (@IPS_GetVariableIDByName($NameTag,$PrevID) >= 1)
		   {
			 if(@GetValueFormatted($NewID) != "")
				{
				  //Formatierten Wert zurckgeben
				  return @GetValueFormatted($NewID);
				}
			 else
				{
					 if (GetValue($NewID) == "")
						 {
						  return "0";
						 }
					 else
                   {
                   //Wert von der Variable lesen und zureuckgeben
			          return (string)GetValue($NewID);
			          }
			   }
		   }
		else
			{
          echo "FEHLER: Variable '" . $NameTag . "' existiert nicht !!! (" . $msgtxt . $Name . ")\r\n";
          return false;
			}
	  }
	else
	  {
      echo "FEHLER: als VARIABLENNAME konnte nur ein Leerstring ermittel werden !!! (" . $msgtxt . $Name . ")\r\n";
      return false;
	  }
 }


/****************************************************************************
CheckCreateVariable,
  prft ob eine Variable in der Objekthierachie existiert bzw. erzeugt diese

  + Achtung:, es wird nur die Variable generiert jedoch nicht Kategorgieebene
				  bzw. Objekthierachien
	           ... dies bitte zuvor mit CheckCreateCategory("AAA/BBB/CCC/DDD") oder
				      von Hand erzeugen

  + Als Trennstrich wird ein Schrgstrich verwendet "/"
		sollte jedoch der Aufruf mit Backslash "\" passieren
		wird dieser automatisch konveriert

Example:  CheckCreateVariable("AAA/BBB/CCC/DDD/TESTVAR1",1,20);
				... wurde eine Variable "TESTVAR1" erzeugen wenn nicht existiert
				... die Variable wird als INTEGER angelegt
				... Defaultwert wird auf 20 gesetzt

VariableTyp: 0=boolean / 1=integer / 2=float / 3=string

ReleaseNotes:
02.04.2009 Gusenbauer
 + Function erstellt und geprft
01.05.2009 Gusenbauer
 + Moeglichkeit einen REALTIVEN PFAD zu uebergeben, wird aber hier schon durch
   CheckObjektHierachie erledigt ==> nur getestet
04.05.2009 Gusenbauer
 + IPS-Funktionen mit @Funktionsname aufrufen
 + Ausgabe des Varibalentyp bei Anlage
 + Defaultwert ist Wert ungleich ""
15.05.2009 Gusenbauer
 + Hilfstexte wegen relativer Pfaderweiterung angepasst
	 - /   ==> Ebene unterhalb des Scriptes
	 - ./  ==> Ebene wie Script
	 - ../ ==> Ebene oberhalb des Scriptes
31.07.2009 Gusenbauer
 + Schreibfehler behoben ($VariableString) ==> WARNINGS in IPS2.1
09.09.2009 Gusenbauer
 + Funktionserweiterung um VariablenProfil, VariablenProfilActionScript und VariablenInfoText
*****************************************************************************/
function CheckCreateVariable($VariablenString,$VariableTyp=1,$VariableDefaultValue="",$VariablenProfil="",$VariablenProfilActionScript="",$VariablenInfoText="")
{
  $NewID = 0; //RootID
  $VariablenString = str_replace(chr(92),"/",$VariablenString);
  $msgtxt ="";
  global $_IPS;

  if (substr($VariablenString,0,1) == "/")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene unterhalb einordnen (Ebene unterhalb des Scriptes)
      global $_IPS;
		$msgtxt = $_IPS['SELF'] . " - " . IPS_GetName($_IPS['SELF']) ." - ";
	  }

  if (substr($VariablenString,0,2) == "./")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie wie Script (Scriptebene)
      global $_IPS;
		$ObjectInfo = IPS_GetObject($_IPS['SELF']);
		$msgtxt = $ObjectInfo['ParentID'] . " - " . IPS_GetName($ObjectInfo['ParentID']) ." - ";
	  }

  if (substr($VariablenString,0,3) == "../")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene hher einordnen (Ebene ber Script)
      global $_IPS;
		$ObjectInfo = IPS_GetObject($_IPS['SELF']);
		$ObjectInfo = IPS_GetObject($ObjectInfo['ParentID']);
		$msgtxt = $ObjectInfo['ParentID'] . " - " . IPS_GetName($ObjectInfo['ParentID']) ." - ";
	  }


  //Check ob sich die Variable in einer Objekthierachie befinden soll
  if (strrpos($VariablenString, "/") !== false)
	  {
		$PathString = substr($VariablenString,0,strrpos($VariablenString, "/")+1);
		$ret = CheckObjektHierachie($PathString);

      if ($ret <= 0)
			{
			 echo("FEHLER: Objektebenenpfad '" . $PathString . "' existiert nicht !!! \r\n");
			 return false;
			}
		else
			{
			$NewID = $ret;
			}
	  }

     $VarString = substr($VariablenString,strlen($PathString));
     $VarID = @IPS_GetVariableIDByName($VarString,$NewID);
  if ($VarID <= 0)
	  {
       if (!isset($VariableTyp))
			 {
			 $VariableTyp = 1;
			 }

		 switch ($VariableTyp)
		  {
		   case 0:
		         $VarID = IPS_CreateVariable(0);
		         $msg_VARTEXT = "als BOOLEAN";
					break;
		   case 1:
		         $VarID = IPS_CreateVariable(1);
		         $msg_VARTEXT = "als INTEGER";
					break;
		   case 2:
		         $VarID = IPS_CreateVariable(2);
		         $msg_VARTEXT = "als FLOAT";
					break;
		   case 3:
		         $VarID = IPS_CreateVariable(3);
		         $msg_VARTEXT = "als STRING";
					break;
		   default:
		         $VarID = IPS_CreateVariable(1);
		         $msg_VARTEXT = "als INTEGER (Default)";
					break;
		  }

		 IPS_SetName($VarID, $VarString);
		 IPS_SetParent($VarID, $NewID);
		 echo ("HINWEIS: Variable ". $VarID . " - " . $VarString . " " . $msg_VARTEXT . " erzeugt");

		 if ($VariableDefaultValue != "")
			 {
           	switch ($VariableTyp)
		       {
		        case 0:
		              if (is_bool($VariableDefaultValue) == true)
							  {
								SetValueBoolean($VarID,$VariableDefaultValue);
							  }
					     break;
		        case 1:
		              if (is_integer($VariableDefaultValue) == true)
							  {
								SetValueInteger($VarID,$VariableDefaultValue);
							  }
					     break;
		        case 2:
		              if (is_float($VariableDefaultValue) == true)
							  {
								SetValueFloat($VarID,$VariableDefaultValue);
							  }
					     break;
		        case 3:
		              if (is_string($VariableDefaultValue) == true)
							  {
								SetValueString($VarID,$VariableDefaultValue);
							  }
					     break;
		        default:
		              if (is_integer($VariableDefaultValue) == true)
							  {
								SetValueInteger($VarID,$VariableDefaultValue);
							  }
					     break;
		       }
            echo (" und Versuch den Defaultwert '". $VariableDefaultValue . "' zuzuweisen");
			 }
      echo (" (" . $msgtxt . $VariablenString . ")\r\n");

		//09.09.2009 Gusenbauer
		if ($VariablenInfoText != "")
		   {
			 IPS_SetInfo($VarID,$VariablenInfoText);
			 echo "HINWEIS: VariablenInfoText '" . $VariablenInfoText . "' wurde der Variable '" . $VarID . " - " . $VarString . "' zugewiesen (" . $msgtxt . $VariablenString .")\r\n";
			}
		else
		   {
		    IPS_SetInfo($VarID,"automatisch generierte Variable am " . date("d.m.Y H:i:s") . " vom Script '" . $_IPS['SELF'] . "-" . IPS_GetName($_IPS['SELF']) . "'");
		   }

      if ($VariablenProfil != "")
		   {
			 if (IPS_VariableProfileExists($VariablenProfil) == true)
			    {
			     IPS_SetVariableCustomProfile($VarID,$VariablenProfil);
			     echo "HINWEIS: VariablenProfil '" . $VariablenProfil . "' wurde der Variable '" . $VarID . " - " . $VarString . "' zugewiesen (" . $msgtxt . $VariablenString .")\r\n";
			    }
			 else
			    {
			     echo "FEHLER: VariablenProfil '" . $VariablenProfil . "' existiert nicht !! ==> keine Zuweisung zur Variable '" . $VarID . " - " . $VarString . "' durchgefhrt (" . $msgtxt . $VariablenString .")\r\n";
			    }
		   }

      if ($VariablenProfilActionScript != "")
         {
			 if (CheckScriptExistsByName($VariablenProfilActionScript) > 0)
			    {
			     IPS_SetVariableCustomAction($VarID,CheckScriptExistsByName($VariablenProfilActionScript));
			     echo "HINWEIS: VariablenProfilActionScript '" . $VariablenProfilActionScript . "' wurde der Variable '" . $VarID . " - " . $VarString . "' zugewiesen (" . $msgtxt . $VariablenString .")\r\n";
			    }
			 else
			    {
			     echo "FEHLER: VariablenProfilActionScript '" . $VariablenProfilActionScript . "' existiert nicht !! ==> keine Zuweisung zur Variable '" . $VarID . " - " . $VarString . "' durchgefhrt (" . $msgtxt . $VariablenString .")\r\n";
			    }
			}
		//************************

	  }

 return IPS_GetVariableIDByName($VarString,$NewID);
 }



/****************************************************************************
CheckObjektHierachie,
  prft ob die Objekthierachie existiert

  + Als Trennstrich wird ein Schrgstrich verwendet "/"
		sollte jedoch der Aufruf mit Backslash "\" passieren
		wird dieser automatisch konveriert
  + Ein Schrgstrich am Ende wird einfach ignoriert
      und stellt keine Probelm dar

Example:  CheckObjektHierachie("AAA/BBB/CCC/DDD/");

ReleaseNotes:
02.04.2009 Gusenbauer
 + Function erstellt und geprft
01.05.2009 Gusenbauer
 + Moeglichkeit einen REALTIVEN PFAD zu uebergeben
15.05.2009 Gusenbauer
 + Relativer Pfad erweitert um
	 - /   ==> Ebene unterhalb des Scriptes
	 - ./  ==> Ebene wie Script
	 - ../ ==> Ebene oberhalb des Scriptes
*****************************************************************************/
function CheckObjektHierachie($ObjectString)
{
  $NewID = 0; //RootID
  $ObjectString = str_replace(chr(92),"/",$ObjectString);
  $msgtxt = "";

  if (substr($ObjectString,0,1) == "/")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene unterhalb einordnen (Ebene unterhalb des Scriptes)
      global $_IPS;
 		$NewID = $_IPS['SELF'];
		$ObjectString = substr($ObjectString,1);
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - /";
	  }

  if (substr($ObjectString,0,2) == "./")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie wie Script (Scriptebene)
      global $_IPS;
		$ObjectInfo = IPS_GetObject($_IPS['SELF']);
		$NewID = $ObjectInfo['ParentID'];
		$ObjectString = substr($ObjectString,2);
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ./";
	  }

  if (substr($ObjectString,0,3) == "../")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene hher einordnen (Ebene ber Script)
      global $_IPS;
		$ObjectInfo = IPS_GetObject($_IPS['SELF']);
		$ObjectInfo = IPS_GetObject($ObjectInfo['ParentID']);
		$NewID = $ObjectInfo['ParentID'];
		$ObjectString = substr($ObjectString,3);
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ../";
	  }

  foreach (explode("/", $ObjectString) as $NameTag)
   {
	 if ($NameTag != "")
		 {
	     $PrevID = $NewID;
	     $NewID = @IPS_GetObjectIDByName($NameTag,$PrevID);
	     if (IPS_GetName($NewID) != $NameTag)
		     {
  			   echo("FEHLER: Objekthierachie '" . $NameTag . "' existiert nicht !! ("  . $msgtxt . $ObjectString .")\r\n");
				break;
				return false;
	        }
		 }
	}
	return $NewID;
}


/****************************************************************************
CheckCreateCategory,
  prft ob die Kategorieebene existiert bzw. erzeugt diese

  + Als Trennstrich wird ein Schrgstrich verwendet "/"
		sollte jedoch der Aufruf mit Backslash "\" passieren
		wird dieser automatisch konveriert
  + Ein Schrgstrich am Ende wird einfach ignoriert
      und stellt keine Probelm dar

Example:  CheckCreateCategory("AAA/BBB/CCC/DDD/");

ReleaseNotes:
02.04.2009 Gusenbauer
 + Function erstellt und geprft
01.05.2009 Gusenbauer
 + Moeglichkeit einen REALTIVEN PFAD zu uebergeben
15.05.2009 Gusenbauer
 + Relativer Pfad erweitert um
	 - /   ==> Ebene unterhalb des Scriptes
	 - ./  ==> Ebene wie Script
	 - ../ ==> Ebene oberhalb des Scriptes
*****************************************************************************/
function CheckCreateCategory($CategoryString)
{
  $NewID = 0; //RootID
  $CategaryString = str_replace(chr(92),"/",$CategoryString);
  $msgtxt = "";

  if (substr($CategoryString,0,1) == "/")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene unterhalb einordnen (Ebene unterhalb des Scriptes)
      global $_IPS;
 		$NewID = $_IPS['SELF'];
		$CategoryString = substr($CategoryString,1);
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - /";
	  }

  if (substr($CategoryString,0,2) == "./")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie wie Script (Scriptebene)
      global $_IPS;
		$ObjectInfo = IPS_GetObject($_IPS['SELF']);
		$NewID = $ObjectInfo['ParentID'];
		$CategoryString = substr($CategoryString,2);
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ./";
	  }

  if (substr($CategoryString,0,3) == "../")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene hher einordnen (Ebene ber Script)
      global $_IPS;
		$ObjectInfo = IPS_GetObject($_IPS['SELF']);
		$ObjectInfo = IPS_GetObject($ObjectInfo['ParentID']);
		$NewID = $ObjectInfo['ParentID'];
		$CategoryString = substr($CategoryString,3);
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ../";
	  }


  foreach (explode("/", $CategoryString) as $NameTag)
   {
	 if ($NameTag != "")
		 {
	     $PrevID = $NewID;
	     $NewID = @IPS_GetCategoryIDByName($NameTag,$PrevID);
	     if (@IPS_GetName($NewID) != $NameTag)
		     {
            $NewID = IPS_CreateCategory();   // Kategorie anlegen
            IPS_SetName($NewID, $NameTag);   // Kategorie benennen
            IPS_SetParent($NewID,$PrevID);   // Kategoriehirachie herstellen
			   echo "HINWEIS: Neue Kategorieebene '" . $NameTag . "' erstellt (" . $msgtxt . $CategoryString .")\r\n";

				//Check ob Kategorie jetzt wirklich existiert
   	      $NewID = IPS_GetCategoryIDByName($NameTag,$PrevID);
	         if (IPS_GetName($NewID) != $NameTag)
		         {
                echo "FEHLER: Kategorieebene '" . $NameTag . "' konnte nicht erzeugt werden !!! (" . $msgtxt . $CategoryString .")\r\n";
					 break;
					 return false;
  			      }
		     }
		 }
	}
	return true;
}


/****************************************************************************
CheckScriptExistsByName,
  prft ob der Script existiert

Example:  CheckScriptExistsByName("AAA/BBB/CCC/DDD/TESTSCRIPT");

ReleaseNotes:
09.09.2009 Gusenbauer
 + Funktion erstellt
*****************************************************************************/
function CheckScriptExistsByName($ScriptString)
{
  $NewID = 0; //RootID
  $ScriptString = str_replace(chr(92),"/",$ScriptString);
  $msgtxt = "";

  if (substr($ScriptString,0,1) == "/")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene unterhalb einordnen (Ebene unterhalb des Scriptes)
      global $_IPS;
 		$NewID = $_IPS['SELF'];
		$ScriptString = substr($ScriptString,1);
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - /";
	  }

  if (substr($ScriptString,0,2) == "./")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie wie Script (Scriptebene)
      global $_IPS;
		$ObjectInfo = IPS_GetObject($_IPS['SELF']);
		$NewID = $ObjectInfo['ParentID'];
		$ScriptString = substr($ScriptString,2);
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ./";
	  }

  if (substr($ScriptString,0,3) == "../")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene hher einordnen (Ebene ber Script)
      global $_IPS;
		$ObjectInfo = IPS_GetObject($_IPS['SELF']);
		$ObjectInfo = IPS_GetObject($ObjectInfo['ParentID']);
		$NewID = $ObjectInfo['ParentID'];
		$ScriptString = substr($ScriptString,3);
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ../";
	  }

  foreach (explode("/", $ScriptString) as $NameTag)
   {
	 if ($NameTag != "")
		 {
	     $PrevID = $NewID;
	     $NewID = @IPS_GetObjectIDByName($NameTag,$PrevID);
	     if (IPS_GetName($NewID) != $NameTag)
		     {
  			   echo("FEHLER: Objekthierachie '" . $NameTag . "' existiert nicht !! ("  . $msgtxt . $ObjectString .")\r\n");
				break;
				return false;
	        }
		 }
	}

   $ObjectInfo = @IPS_GetObject($NewID);
   if ($ObjectInfo['ObjectType'] == 3) // 3 = ist ein Script
 	   {
	    return $NewID;
	   }
  else
	   {
		 return false;
	   }

}




/****************************************************************************
SetValueBooleanByName,
SetValueIntegerByName,
SetValueFloatByName,
SetValueStringByName,
  schreibt auf die Variableenstring den Uebergabewert

  + Als Trennstrich wird ein Schrgstrich verwendet "/"
		sollte jedoch der Aufruf mit Backslash "\" passieren
		wird dieser automatisch konveriert

Example:  SetValueBooleanByName("AAA/BBB/CCC/DDD/TESTVAR1",TRUE);
          SetValueIntegerByName("AAA/BBB/CCC/DDD/TESTVAR1",1234);
          SetValueFloatByName("AAA/BBB/CCC/DDD/TESTVAR1",23.67e-2);
          SetValueStringByName("AAA/BBB/CCC/DDD/TESTVAR1","Das ist ein Test");

ReleaseNotes:
04.05.2009 Gusenbauer
 + Code nach _SetValueByName ausgelagert
*****************************************************************************/
function SetValueBooleanByName($Name,$Value)
 {
  return _SetValueByName(0,0,$Name,$Value);
 }

function SetValueIntegerByName($Name,$Value)
 {
  return _SetValueByName(1,0,$Name,$Value);
 }

function SetValueFloatByName($Name,$Value)
 {
  return _SetValueByName(2,0,$Name,$Value);
 }

function SetValueStringByName($Name,$Value)
 {
  return _SetValueByName(3,0,$Name,$Value);
 }


/****************************************************************************
SetValueBooleanByNameCC,
SetValueIntegerByNameCC,
SetValueFloatByNameCC,
SetValueStringByNameCC,
  schreibt auf die Variableenstring den Uebergabewert und erzeugt fehlende
  Objekthierachien mit Kategorieebenen und erzeugt auch die Variable

  + Als Trennstrich wird ein Schrgstrich verwendet "/"
		sollte jedoch der Aufruf mit Backslash "\" passieren
		wird dieser automatisch konveriert

Example:  SetValueBooleanByNameCC("AAA/BBB/CCC/DDD/TESTVAR1",TRUE);
          SetValueIntegerByNameCC("AAA/BBB/CCC/DDD/TESTVAR1",1234);
          SetValueFloatByNameCC("AAA/BBB/CCC/DDD/TESTVAR1",23.67e-2);
          SetValueStringByNameCC("AAA/BBB/CCC/DDD/TESTVAR1","Das ist ein Test");

ReleaseNotes:
05.05.2009 Gusenbauer
 + Funktionen erstellt
09.09.2009 Gusenbauer
 + Erweiterung um VaribalenProfil, VariablenActionScript und VariablenInfo

*****************************************************************************/
function SetValueBooleanByNameCC($Name,$Value,$VarProfil="",$VarProfilActionScript="",$VarInfoText="")
 {
  return _SetValueByName(0,1,$Name,$Value,$VarProfil,$VarProfilActionScript,$VarInfoText);
 }

function SetValueIntegerByNameCC($Name,$Value,$VarProfil="",$VarProfilActionScript="",$VarInfoText="")
 {
  return _SetValueByName(1,1,$Name,$Value,$VarProfil,$VarProfilActionScript,$VarInfoText);
 }

function SetValueFloatByNameCC($Name,$Value,$VarProfil="",$VarProfilActionScript="",$VarInfoText="")
 {
  return _SetValueByName(2,1,$Name,$Value,$VarProfil,$VarProfilActionScript,$VarInfoText);
 }

function SetValueStringByNameCC($Name,$Value,$VarProfil="",$VarProfilActionScript="",$VarInfoText="")
 {
  return _SetValueByName(3,1,$Name,$Value,$VarProfil,$VarProfilActionScript,$VarInfoText);
 }


/****************************************************************************
ConvertToBoolean,
  konvertiert den bergabewert in Boolaen (Default = FALSE) !!

Example:  ConvertToBoolean(1);

ReleaseNotes:
02.04.2009 Gusenbauer
 + Check ob bergabewert einen STRING entspricht
*****************************************************************************/
function ConvertToBoolean($Value)
 {
	 $Value = strtoupper($Value);

	 if (in_array($Value,array('TRUE', 'YES', 'Y', '1', 'ON', 'EIN', 'J', 'JA', true, 1), true))
	     {
        return true;
        }
	 else
		  {
		  return false;
		  }
 }



/****************************************************************************
GetAllVariablesOfObjectHierachieForVisual,
  holt alle Varibalen der Objekthierachie von IPS und bau ein INFO-ARRAY !!

Example:  $VARIDs = GetAllVariablesOfObjectHierachieForVisual("S7/PALETTENNUMMERN/");
          while($ID = each($VARIDs))
            {
             print("<H6>VariableID: " . $ID[1]['ID']. " - " . $ID[1]['NAME']
				      ." - Wert = " . $ID[1]['VALUE']
						."(letzter Werte change = " . $ID[1]['TS_CHANGE']
						." letztes Update = " . $ID[1]['TS_UPDATE'] .")</H6>");
            }

ReleaseNotes:
03.04.2009 Gusenbauer
 + Einfuehrung der Function
*****************************************************************************/
function GetAllVariablesOfObjectHierachieForVisual($VaribalenPath)
  {

    $VaribalenPathID = @CheckObjektHierachie($VaribalenPath);
    $VARINFO_ARRAY = array();

    if($VaribalenPathID >= 1)
      {
       $PathChilds = @IPS_GetChildrenIDs($VaribalenPathID);

       foreach ($PathChilds as $ChildID)
             {
              $ChildIDINFO = @IPS_GetObject($ChildID);
              if ($ChildIDINFO['ObjectType'] == 2) //Check ob Objekt eine Variable ist
                 {
                  $VarInfo = @IPS_GetVariable($ChildID);

                  $VARINFO_ARRAY[$ChildIDINFO['ObjectName']]['ID']         = $ChildIDINFO['ObjectID'];
                  $VARINFO_ARRAY[$ChildIDINFO['ObjectName']]['NAME']       = $ChildIDINFO['ObjectName'];
                  $VARINFO_ARRAY[$ChildIDINFO['ObjectName']]['VALUE']      = GetValue($ChildID);
                  $VARINFO_ARRAY[$ChildIDINFO['ObjectName']]['TS_UPDATE']  = date("d.m.Y H:i:s", $VarInfo['VariableUpdated']);
                  $VARINFO_ARRAY[$ChildIDINFO['ObjectName']]['TS_CHANGE']  = date("d.m.Y H:i:s", $VarInfo['VariableChanged']);
                  $VARINFO_ARRAY[$ChildIDINFO['ObjectName']]['TS_UPDATE_UNIX']  = $VarInfo['VariableUpdated'];
                  $VARINFO_ARRAY[$ChildIDINFO['ObjectName']]['TS_CHANGE_UNIX']  = $VarInfo['VariableChanged'];
                 }
             }
      }
    else
      {
        exit("FEHLER: Objectpath : '" . $VaribalenPath ."' ist nicht in IPS vorhanden !!\r\n");
      }

   return $VARINFO_ARRAY;
  }


/****************************************************************************
INTERNE FUNCTIONEN NICHT FUER DEN EXTERNEN AUFRUF GEEIGNET
*****************************************************************************/

/****************************************************************************
_SetValueByName,
  schreibt auf die Variableenstring den Uebergabewert

  + Als Trennstrich wird ein Schrgstrich verwendet "/"
		sollte jedoch der Aufruf mit Backslash "\" passieren
		wird dieser automatisch konveriert

Example:  _SetValueByName(3,1,"AAA/BBB/CCC/DDD/TESTVAR1","Das ist ein Test");

VariablenTyp: 0=boolean / 1=integer / 2=float / 3=string
CheckCreate:  0= Objekthierachie und Variable muss existieren
				  1= Fehlende Objektebenen werden als Kategorieelemente gefuellt
				 	  und die Variable wird erzeugt
ReleaseNotes:
04.05.2009 Gusenbauer
 + Funktion fuer alle SetValue*ByName eine globale Funktion gebaut
	  - alte ReleaseNotes der Funktionen
            29.03.2009 Gusenbauer
             + Function erstellt und geprft
            02.04.2009 Gusenbauer
             + Check ob "letzter Teilstring" wirklich eine VARIABLE ist
            01.05.2009 Gusenbauer
             + Moeglichkeit einen REALTIVEN PFAD zu uebergeben
05.05.2009 Gusenbauer
 + Funktion um CHECK AND CREATE erweitert, weil dadurch nur
   mehr eine Funktionaufruf in den Scripten erfolgen muss und der Ablauf optimiert ist
15.05.2009 Gusenbauer
 + Relativer Pfad erweitert um
	 - /   ==> Ebene unterhalb des Scriptes
	 - ./  ==> Ebene wie Script
	 - ../ ==> Ebene oberhalb des Scriptes
13.07.2009 Gusenbauer
 + BUGFIX --> bei relativen Pfad Variable "$PathString" initialisieren, hat zu
	"Warnings" in IPS2.1 Beta gefuehrt ==> wegen error_reporting=E_ALL
09.09.2009 Gusenbauer
 + Erweiterung um VariablenProfil und VariablenProfilActionScript
21.04.2010 Gusenbauer
 + IPS_SELF mit global uebergeben

*****************************************************************************/
function _SetValueByName($VariablenTyp,$CheckCreate,$VariablenString,$Value,$VariablenProfil="",$VariablenProfilActionScript="",$VariablenInfoText="")
{
  global $_IPS;
  $NewID = 0; //RootID
  $VariablenString = str_replace(chr(92),"/",$VariablenString);

  $msgtxt = "";
  $msgtxt_function = "";


  if (substr($VariablenString,0,1) == "/")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene unterhalb einordnen (Ebene unterhalb des Scriptes)
      global $_IPS;
 		$NewID = $_IPS['SELF'];
		$VariablenString = substr($VariablenString,1);
		$PathString = "";
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - /";
	  }

  if (substr($VariablenString,0,2) == "./")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie wie Script (Scriptebene)
      global $_IPS;
		$ObjectInfo = IPS_GetObject($_IPS['SELF']);
		$NewID = $ObjectInfo['ParentID'];
		$VariablenString = substr($VariablenString,2);
		$PathString = "";
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ./";
	  }

  if (substr($VariablenString,0,3) == "../")
	  {
		//Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene hher einordnen (Ebene ber Script)
      global $_IPS;
		$ObjectInfo = IPS_GetObject($_IPS['SELF']);
		$ObjectInfo = IPS_GetObject($ObjectInfo['ParentID']);
		$NewID = $ObjectInfo['ParentID'];
		$VariablenString = substr($VariablenString,3);
	   $PathString = "";
		$msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ../";
	  }


  if ($CheckCreate == 1)
     {
		//Check ob ein Element der Objektebene fehlt und noetigenfalls durch
		//ein Kategorieebenenelemt auffuellen + Variable erzeugen

		//Check ob sich die Variable in einer Objekthierachie befinden soll
      if (strrpos($VariablenString, "/") !== false)
	      {
		    $PathString = substr($VariablenString,0,strrpos($VariablenString, "/")+1);

          foreach (explode("/", $PathString) as $NameTag)
            {
	          if ($NameTag != "")
		          {
	              $PrevID = $NewID;
	              $NewID = @IPS_GetObjectIDByName($NameTag,$PrevID);
	                if (IPS_GetName($NewID) != $NameTag)
		                {
  			              //Fehlendes Objekt durch Kategorieelement auffuellen
  			              $NewID = IPS_CreateCategory();   // Kategorie anlegen
                       IPS_SetName($NewID, $NameTag);   // Kategorie benennen
                       IPS_SetParent($NewID,$PrevID);   // Kategoriehirachie herstellen
			              echo "HINWEIS: Neue Kategorieebene '" . $NameTag . "' erstellt (" . $msgtxt . $VariablenString .")\r\n";

				           //Check ob Kategorie jetzt wirklich existiert
   	                 $NewID = IPS_GetCategoryIDByName($NameTag,$PrevID);
	                    if (IPS_GetName($NewID) != $NameTag)
		                    {
                           echo "FEHLER: Kategorieebene '" . $NameTag . "' konnte nicht erzeugt werden !!! (" . $msgtxt . $VariablenString .")\r\n";
					            break;
					            return false;
  			                 }
	                   }
		          }
	         }
	      }

         $PrevID = $NewID;
         $VarString = substr($VariablenString,strlen($PathString));
         $VarID = @IPS_GetVariableIDByName($VarString,$PrevID);

	      //existiert die Variable nicht
         if ($VarID <= 0)
	         {
    	       switch ($VariablenTyp)
		              {
		              case 0:
		                     $VarID = IPS_CreateVariable(0);
		                     $msg_VARTEXT = "als BOOLEAN";
					            break;
		              case 1:
		                     $VarID = IPS_CreateVariable(1);
		                     $msg_VARTEXT = "als INTEGER";
					            break;
		              case 2:
		                     $VarID = IPS_CreateVariable(2);
		                     $msg_VARTEXT = "als FLOAT";
					            break;
		              case 3:
		                     $VarID = IPS_CreateVariable(3);
		                     $msg_VARTEXT = "als STRING";
					            break;
		              default:
		                     $VarID = IPS_CreateVariable(1);
		                     $msg_VARTEXT = "als INTEGER (Default)";
					            break;
		              }

		       if (IPS_SetName($VarID, $VarString) == false)
				    {
                 echo "FEHLER: VariablenName '" . $VarString . "' kann nicht auf ObjektID " . $VarID . " zugewiesen werden !!! (" . $msgtxt . $VariablenString .")\r\n";
				     return false;
				    }

		       if (IPS_SetParent($VarID, $NewID) == false)
				    {
                 echo "FEHLER: Variable '" . $VarID . " - " . $VarString . "' kann nicht den ParentObjekt " . $NewID . " zugewiesen werden !!! (" . $msgtxt . $VariablenString .")\r\n";
				     return false;
				    }

             echo "HINWEIS: Neue Variable '" . $VarID . " - " . $VarString . "' " . $msg_VARTEXT ." erzeugt (". $msgtxt . $VariablenString .")\r\n";

				 //09.09.2009 Gusenbauer
				 if ($VariablenInfoText != "")
					 {
					  IPS_SetInfo($VarID,$VariablenInfoText);
					  echo "HINWEIS: VariablenInfoText '" . $VariablenInfoText . "' wurde der Variable '" . $VarID . " - " . $VarString . "' zugewiesen (" . $msgtxt . $VariablenString .")\r\n";
					 }
				 else
					 {
					  IPS_SetInfo($VarID,"automatisch generierte Variable am " . date("d.m.Y H:i:s") . " vom Script '" . $_IPS['SELF'] . "-" . IPS_GetName($_IPS['SELF']) . "'");
					 }

				 if ($VariablenProfil != "")
					 {
				     if (IPS_VariableProfileExists($VariablenProfil) == true)
				        {
					      IPS_SetVariableCustomProfile($VarID,$VariablenProfil);
					      echo "HINWEIS: VariablenProfil '" . $VariablenProfil . "' wurde der Variable '" . $VarID . " - " . $VarString . "' zugewiesen (" . $msgtxt . $VariablenString .")\r\n";
				        }
				     else
					     {
					      echo "FEHLER: VariablenProfil '" . $VariablenProfil . "' existiert nicht !! ==> keine Zuweisung zur Variable '" . $VarID . " - " . $VarString . "' durchgefhrt (" . $msgtxt . $VariablenString .")\r\n";
					     }
					 }

		       if ($VariablenProfilActionScript != "")
                {
					  if (CheckScriptExistsByName($VariablenProfilActionScript) > 0)
				        {
					      IPS_SetVariableCustomAction($VarID,CheckScriptExistsByName($VariablenProfilActionScript));
					      echo "HINWEIS: VariablenProfilActionScript '" . $VariablenProfilActionScript . "' wurde der Variable '" . $VarID . " - " . $VarString . "' zugewiesen (" . $msgtxt . $VariablenString .")\r\n";
				        }
				     else
					     {
					      echo "FEHLER: VariablenProfilActionScript '" . $VariablenProfilActionScript . "' existiert nicht !! ==> keine Zuweisung zur Variable '" . $VarID . " - " . $VarString . "' durchgefhrt (" . $msgtxt . $VariablenString .")\r\n";
					     }
					 }
				 //************************

				 //Wegen kompatibilitaet zur "NUR OBJEKTHIERACHIE" pruefen
				 $NewID = $VarID;

           }
         else
			  {
				//Wegen kompatibilitaet zur "NUR OBJEKTHIERACHIE" pruefen
				$NewID = $VarID;
			  }
		}
  else
		{
		 //Nur Objekthierachie pruefen
		 foreach (explode("/", $VariablenString) as $VarString)
         {
	       $PrevID = $NewID;
	       $NewID = @IPS_GetObjectIDByName($VarString,$PrevID);
	       if (@IPS_GetName($NewID) != $VarString)
		       {
		        echo "FEHLER: Pfad / Variable '" . $VarString ."' existiert nicht !!(" . $msgtxt . $VariablenString . ")\r\n";
			     return false;
			     break;
		       }
	      }
		}


  if ($VarString != "")
	  {
	   if (@IPS_GetVariableIDByName($VarString,$PrevID) >= 1)
		   {

		     //Wert auf VariablenID zuweisen
       	  switch ($VariablenTyp)
		            {
		            case 0:
		                   $ret = @SetValueBoolean($NewID,ConvertToBoolean($Value));
		                   $msgtxt_function = "SetValueBoolean";
					          break;
		            case 1:
		                   $ret = @SetValueInteger($NewID,$Value);
		                   $msgtxt_function = "SetValueInteger";
					          break;
		            case 2:
		                   $ret = @SetValueFloat($NewID,$Value);
		                   $msgtxt_function = "SetValueFloat";
					          break;
		            case 3:
		                   $ret = @SetValueString($NewID,$Value);
		                   $msgtxt_function = "SetValueString";
					          break;
		            default:
		                   echo "FEHLER: '_SETVALUEBYNAME' -  Interner Funktionsaufruf unbekannt !!\r\n";
		                   $msgtxt_function = " ?????? ";
							    $ret = false;
					          break;
		           }

				  //Rueckgabewert der ZUWEISFUNKTION pruefen
              if ($ret == true)
	              {
	               return true;
	              }
              else
				     {
		            echo "FEHLER: Wert '" . $Value . "' konnte mit " . $msgtxt_function ." nicht auf die ID: " . $NewID . " zuwegwiesen werden (" . $msgtxt . $VariablenString . ")\r\n";
		            return false;
	              }
		   }
		else
			{
          echo "FEHLER: Variable '" . $PrevID . " - " . $VarString . "' existiert nicht !!! (" . $msgtxt . $VariablenString . ")\r\n";
          return false;
			}
	  }
	else
	  {
      echo "FEHLER: als VARIABLENNAME konnte nur ein Leerstring ermittel werden !!! (" . $msgtxt . $VariablenString . ")\r\n";
      return false;
	  }
 }


/****************************************************************************
UUID,
- liefert einen Universally Unique IDentifier (UUID)

Sourcecode:
     * RFC 4122 (http://www.ietf.org/rfc/rfc4122.txt) defines a special type
	  * of Globally Unique IDentifiers (GUID)
     *
     * @copyright  Copyright (c) CFD Labs, 2006. This function may be used
	  *             freely for any purpose ; it is distributed without any
	  *             form of warranty whatsoever.
	  *
     * @author      David Holmes <dholmes@cfdsoftware.net>
     *
     * @return  string  A UUID, made up of 32 hex digits and 4 hyphens.

Example:     echo UUID();
Return:      {572C3801-322F-9FF4-116E-DA377082A359}

ReleaseNotes:
07.11.2009 Gusenbauer
*****************************************************************************/
function UUID()
 {
   // The field names refer to RFC 4122 section 4.1.2

   return sprintf(chr(123) . strtoupper('%04x%04x-%04x-%03x4-%04x-%04x%04x%04x'). chr(125),
       mt_rand(0, 65535), mt_rand(0, 65535), // 32 bits for "time_low"
       mt_rand(0, 65535), // 16 bits for "time_mid"
       mt_rand(0, 4095),  // 12 bits before the 0100 of (version) 4 for "time_hi_and_version"
       bindec(substr_replace(sprintf('%016b', mt_rand(0, 65535)), '01', 6, 2)),
           // 8 bits, the last two of which (positions 6 and 7) are 01, for "clk_seq_hi_res"
           // (hence, the 2nd hex digit after the 3rd hyphen can only be 1, 5, 9 or d)
           // 8 bits for "clk_seq_low"
       mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535) // 48 bits for "node"
   );
 }


/****************************************************************************
GUID,
- liefert einen Globally Unique IDentifier (GUID)

Sourcecode:  http://php.net/manual/en/function.com-create-guid.php
Example:     echo GUID();
Return:      {451EB352-B8E9-49A7-B864-AE5112CA2FB2}

ReleaseNotes:
07.11.2009 Gusenbauer
*****************************************************************************/
function GUID()
 {
  if (function_exists('com_create_guid'))
     {
      return com_create_guid();
     }
  else
     {
      mt_srand((double)microtime()*10000);//optional for php 4.2.0 and up.
      $charid = strtoupper(md5(uniqid(rand(), true)));
      $hyphen = chr(45);// "-"
      $uuid = chr(123)// "{"
              .substr($charid, 0, 8).$hyphen
              .substr($charid, 8, 4).$hyphen
              .substr($charid,12, 4).$hyphen
              .substr($charid,16, 4).$hyphen
              .substr($charid,20,12)
              .chr(125);// "}"
      return $uuid;
    }
 }

/****************************************************************************
ENDE
*****************************************************************************/
?>